﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Windows.Threading; 

namespace TBASDKCS_WF
{
    public partial class Form1 : Form
    {
        TBASDKClass m_LARun;
        string strSN;
		string strErrorString;
		TBASDKClass.LA_HW_MODE m_giHwMode;
		TBASDKClass.TRIG m_tr = new TBASDKClass.TRIG();
        DispatcherTimer MainTimerClock;


        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
			m_LARun = new TBASDKClass();
			m_giHwMode = TBASDKClass.LA_HW_MODE.TBA_HWMODE_LA200M;
			byte[] szBuf = System.Text.Encoding.ASCII.GetBytes("12345" + "\0");
			int iSize = szBuf.Count();
        }

        private void btn_GetHW_Click(object sender, EventArgs e)
        {
			if (m_LARun.ulaSDKInit())
			{
				m_LARun.ulaSDKThreshold(0, 1600);			// 1.6V (TTL)
				m_LARun.ulaSDKThreshold(1, 1600);			// 1.6V (TTL)

				strSN = m_LARun.ulaSDKGetSerialNumber();
				edLAModel.Text = "SN = " + strSN;

				btn_Capture.Enabled = true;
				btn_GetHW.Enabled = false;
				lbStatusDisplay.Text = "H/W Initialized";
			}
			else
			{
				ShowErrorCode();
			}
        }

		private void SetTrigger()
		{
			int iTrigChannel = 1;
			int iTrigLevel = 0;
			int iTrigCondition = TBASDKClass.LA_TRIG_CHANGE;
			int iTrigContinue = TBASDKClass.TR_CONTINUE;
			if (!m_LARun.ulaSDKClearTrigger(ref m_tr))	//clear the trigger setting to free run
			{
				ShowErrorCode();
				return;
			}
			if (!m_LARun.ulaSDKSetChTrigger(ref m_tr, iTrigLevel, iTrigChannel, iTrigCondition, iTrigContinue))	//set trigger for level 0
			{
				ShowErrorCode();
				return;
			}
			//if (!m_LARun.ulaSDKSetChTrigger(ref m_tr, iTrigLevel2, iTrigChannel2, iTrigCondition2, iTrigContinue2))	//set trigger for level 1 if need
			//{
			//    ShowErrorCode();
			//    return;
			//}
		}

        private void btn_Capture_Click(object sender, EventArgs e)
        {
            btn_Capture.Enabled = false;
            btn_Stop.Enabled = true;

			//Set trigger condition to single level trigger
			SetTrigger();
			
            m_tr.iDelay = 0;						// for LA2000P
            m_tr.iExtClk = 1;						// 1: Use Internal Clock
            m_tr.iFlag = TBASDKClass.TR_PRETRIG;
			m_tr.iFreq = (uint)(200E6);
			m_tr.iFreqHi = (int)((UInt64)200E6 >> 32);
            m_tr.iPassCount = 0;					// No Pass Count
            m_tr.iTrPos = 50;						// Trigger signal located at point 50
            m_tr.iWidth = 0;						// for LA2000P

			//TBA is working in Transitional storage 
				m_giHwMode = TBASDKClass.LA_HW_MODE.TBA_HWMODE_LA200M;

			//Select HW mode
			if (!m_LARun.ulaSDKSetHwInfo((int)TBASDKClass.LA_HW_SETTING.SET_TL_MODE, (int)m_giHwMode))
			{
				ShowErrorCode();
				return;
			}

			//Set Ram Size 32MB, RAM size must be Multiple of 32
			m_LARun.ulaSDKSetRamSize(32);
			
			
			//Set Trigger position to 1%
			m_tr.iTrPos = 1;
			

			if (!m_LARun.ulaSDKCapture(ref m_tr))
			{
				ShowErrorCode();
				return;
			}

            MainTimerClock = new DispatcherTimer();
            //Creates a timerClock and enables it
            MainTimerClock.Interval = new TimeSpan(100);
            MainTimerClock.IsEnabled = true;
            MainTimerClock.Tick += new EventHandler(MainTimerClockProc);
			lbStatusDisplay.Text = "Capturing...";
        }

        public void MainTimerClockProc(object sender, EventArgs e)
        {
			//Check Trigger ready
			if (m_LARun.ulaSDKIsTriggered() != false)
				lbStatusDisplay.Text = "Capturing...Triggered";
			else
				lbStatusDisplay.Text = "Capturing...";
            // Wait Data ready
			bool fIsCaptureReady = m_LARun.ulaSDKIsCaptureReady();
			if (fIsCaptureReady)
            {
                btn_Capture.Enabled = true;
                btn_Stop.Enabled = false;
                MainTimerClock.Stop();
				lbStatusDisplay.Text = "Capture Finished";

                // When data ready then read it.
					ReadTrWaveAndWriteFile();				
				
                Invalidate();
            }
        }

		private void ReadTrWaveAndWriteFile()
		{
			//Debug used Environment setting
			const string strFilePath = "D:\\TBASDK_TransText.txt";
			const int iMaxLine = 200;
			///////////////////////////////////

			string strTimestamp;
			string strData;
			string strText;
			const int iChCount = 16;	//Max 16Channel
			Int64 i64TimestampHead = 0;
			Int64 i64TimestampEnd = 0;
			Int64 i64TimestampTrig = 0;
			Int64 i64Timestamp = 0;
			int iLine = 0;
			Int64 i64WaveData = 0;
			double dbSampleInterval_ns = 1E9 / m_tr.iFreq;

			System.IO.StreamWriter swFile = System.IO.File.CreateText(strFilePath);
			listData.Items.Clear(); //Clear all exist data
			strText = "Timestamp, CH15        0\r\n";
			swFile.Write(strText);
			listData.Items.Add(strText);
			
			if (m_LARun.ulaSDKGetTimingInfo(ref i64TimestampHead, ref i64TimestampEnd, ref i64TimestampTrig))
			{
				i64Timestamp = i64TimestampHead;
				while (i64Timestamp != i64TimestampEnd && m_LARun.ulaSDKGetNextData(ref i64WaveData, ref i64Timestamp))				
				{
					strTimestamp = ((i64Timestamp - i64TimestampHead) * dbSampleInterval_ns).ToString() + "ns";
					strData = "";
					for (int i = iChCount - 1; i >= 0; i--)
					{						
						strData += Convert.ToString((i64WaveData >> i) & 0x01);
						if (i == 8)
							strData += " ";
					}

					strText = strTimestamp + "," + strData + "\r\n";
					if (iLine < 50) //Maximum display line = 50
						listData.Items.Add(strText);
					swFile.Write(strText);
					iLine++;

					if (iLine > iMaxLine)	//debug max line check
						break;

					
				}
				swFile.Close();
			}

		}

        private void btn_Stop_Click(object sender, EventArgs e)
        {
            MainTimerClock.Stop();
			if (!m_LARun.ulaSDKStopCapture())
			{
				ShowErrorCode();
				return;
			}
			
			//Collect data to a text file, no waveform drawing here
				ReadTrWaveAndWriteFile();
			
			btn_Capture.Enabled = true;
			btn_Stop.Enabled = false;
        }

		private void ShowErrorCode()
		{
			int iErrorCode = m_LARun.ulaSDKGetLastError();
			strErrorString = "ErrorCode = " + ((LA_ErrorCode.ErrorCode)iErrorCode).ToString();
			MessageBox.Show(strErrorString);
		}

		private void bnSaveTBW_Click(object sender, EventArgs e)
		{
			if (!m_LARun.ulaSDKSaveAsLawFile("D:\\TBASDKCsharp.tbw"))
				ShowErrorCode();
		}

    }
}
