﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using DWORD = System.UInt32;

namespace TBASDKCS_WF
{
    public class TBASDKClass
    {
		// Import the TbaSDK.DLL
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKInit", CallingConvention = CallingConvention.StdCall)]
		private static extern bool _ulaSDKInit();
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKShutdown", CallingConvention = CallingConvention.StdCall)]
		private static extern bool _ulaSDKShutdown();
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKThreshold", CallingConvention = CallingConvention.StdCall)]
		private static extern bool _ulaSDKThreshold(int iPod, int iMiniVolt);
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKGetSerialNumber", CallingConvention = CallingConvention.StdCall)]
		private static extern bool _ulaSDKGetSerialNumber(StringBuilder pBuf, int iSize);
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKIsCaptureReady", CallingConvention = CallingConvention.StdCall)]
		private static extern bool _ulaSDKIsCaptureReady();
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKIsTriggered", CallingConvention = CallingConvention.StdCall)]
		private static extern bool _ulaSDKIsTriggered();
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKClearTrigger", CallingConvention = CallingConvention.StdCall)]
		private static extern bool _ulaSDKClearTrigger(ref TRIG lptr);
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKSetChTrigger", CallingConvention = CallingConvention.StdCall)]
		private static extern bool _ulaSDKSetChTrigger(ref TRIG lptr, int iLevel, int iCh, int iTrig, int iCondLogic);
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKCapture", CallingConvention = CallingConvention.StdCall)]
		private static extern bool _ulaSDKCapture(ref TRIG lptr);
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKStopCapture", CallingConvention = CallingConvention.StdCall)]
		private static extern bool _ulaSDKStopCapture();
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKGetBusData", CallingConvention = CallingConvention.StdCall)]
		private static extern bool _ulaSDKGetBusData(int iMSB, int iLSB, UInt32[] pUserData, ref int lpiSize, int iStartSamplePos);
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKGetChData", CallingConvention = CallingConvention.StdCall)]
		private static extern bool _ulaSDKGetChData(int iCh, UInt32[] pUserData, ref int lpiSize, int iStartSamplePos);
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKSetHwInfo", CallingConvention = CallingConvention.StdCall)]
		private static extern bool _ulaSDKSetHwInfo(int iIndex, ref int iValue);
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKGetMaxSamplesNum", CallingConvention = CallingConvention.StdCall)]
        private static extern int _ulaSDKGetMaxSamplesNum();
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKGetSamplesNum", CallingConvention = CallingConvention.StdCall)]
        private static extern int _ulaSDKGetSamplesNum();
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKSetRamSize", CallingConvention = CallingConvention.StdCall)]
        private static extern bool _ulaSDKSetRamSize(int iSizeMB);
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKGetBufferSizeInBytes", CallingConvention = CallingConvention.StdCall)]
        private static extern int _ulaSDKGetBufferSizeInBytes();
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKGetLastError", CallingConvention = CallingConvention.StdCall)]
		private static extern int _ulaSDKGetLastError();

		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKSaveAsLawFile", CallingConvention = CallingConvention.StdCall)]
		private static extern bool _ulaSDKSaveAsLawFile(byte[] szFilePathName);
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKSaveAsLawFileWithTemplate", CallingConvention = CallingConvention.StdCall)]
		private static extern bool _ulaSDKSaveAsLawFileWithTemplate(byte[] szFilePathName, byte[] szFileTemplateName);

		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKGetTimingInfo", CallingConvention = CallingConvention.StdCall)]
		private static extern bool _ulaSDKGetTimingInfo(ref Int64 i64TrHead, ref Int64 i64TrEnd, ref Int64 i64TrPos);
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKGetDataAt", CallingConvention = CallingConvention.StdCall)]
		private static extern bool _ulaSDKGetDataAt(ref Int64 i64Data, Int64 i64Timestamp);
		[DllImport("TbaSDK.dll", EntryPoint = "ulaSDKGetNextData", CallingConvention = CallingConvention.StdCall)]
		private static extern bool _ulaSDKGetNextData(ref Int64 i64Data, ref Int64 i64Timestamp);

        public const int TB_MAX_CH_SIZE = 16;

        public const int TR_CONTINUE = 0;
        public const int TR_DISCONTINUE = 1;
        public const int TR_END = 2;

        public const int LA_TRIG_LOW = 0;
		public const int LA_TRIG_FALLING = 2;
		public const int LA_TRIG_RISING = 4;
        public const int LA_TRIG_HIGH = 6;		
        public const int LA_TRIG_DONT_CARE = 8;
		public const int LA_TRIG_CHANGE = 10;

        public const int TR_ONELEVEL = 0;
        public const int TR_MULTILEVEL = 1;
        public const int TR_DUALCOND = 2;

		public enum LA_HW_SETTING
		{
			SET_TL_MODE = 5,
			SET_TL_QUALIFICATION = 7,
			SET_TL_GLITCH_FILTER = 8,
		};

		public enum LA_HW_MODE
		{
			TBA_HWMODE_LA200M = 200,
		};

        // _TRIG:iFlag
		public const int TR_DBLMODE = 0x00000001;  // LA work in double freq. mode
		public const int TR_PRETRIG = 0x00000002; // LA work in Pre-trig. mode
      
        
        [StructLayout(LayoutKind.Sequential)]
        public struct TRIG
        {
			public int		iFlag;          // Flag of trigger condition
			public int		iDelay;         // delay trigger setting(unit: clocks)
			public int		iWidth;         // pulse width trigger settings(unit: Clocks)
			public int		iPassCount;     // pass count of trigger condition
			public uint		iFreq;          // LA current sampling rate
			public int		iFreqHi;		// LA current sampling rate (High 32 Bit)
			public int		iExtClk;		// use external clock(if iExtClk = 1: use internal clock)
			public int		iTrPos;			// trigger position
			[MarshalAsAttribute(UnmanagedType.ByValArray, SizeConst = 16)]
			public int[]	lpiCont;       // the trigger condition is running? length is iLvl(unit:int)
			[MarshalAsAttribute(UnmanagedType.ByValArray, SizeConst = 1024)]
			public byte[]	lpbTrigData;   // Trigger data, length = iCh*iLvl (unit: byte)
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct HW_INFO{
            public UInt16 wID; 
            public string pName;
        };

		public bool ulaSDKInit()
        {
			return _ulaSDKInit();
        }
		public bool ulaSDKShutdown()
        {
			return _ulaSDKShutdown();
        }
		public bool ulaSDKThreshold(int iPod, int iMiniVolt)
        {
			return _ulaSDKThreshold(iPod, iMiniVolt);
        }
		public string ulaSDKGetSerialNumber()
		{
			StringBuilder sb = new StringBuilder(64);		

			if (_ulaSDKGetSerialNumber(sb, sb.Capacity + 1) == true)
				return sb.ToString();
			else
				return "";
		}
		public bool ulaSDKIsCaptureReady()
		{
			return _ulaSDKIsCaptureReady();
		}
		public bool ulaSDKIsTriggered()
		{
			return _ulaSDKIsTriggered();
		}
		public bool ulaSDKSetChTrigger(ref TRIG lptr, int iLevel, int iCh, int iTrig, int iCondLogic)
        {
			return _ulaSDKSetChTrigger(ref lptr, iLevel, iCh, iTrig, iCondLogic);
        }
		public bool ulaSDKClearTrigger(ref TRIG lptr)
		{
			return _ulaSDKClearTrigger(ref lptr);
		}
		public bool ulaSDKCapture(ref TRIG lptr)
        {
            return _ulaSDKCapture(ref lptr);
        }
		public bool ulaSDKGetBusData(int iMSB, int iLSB, UInt32[] pUserData, int lpiSize, int iStartSamplePos)
        {
			return _ulaSDKGetBusData(iMSB, iLSB, pUserData, ref lpiSize, iStartSamplePos);
        }
		public bool ulaSDKGetChData(int iCh, UInt32[] pUserData, int lpiSize, int iStartSamplePos)
		{
			return _ulaSDKGetChData(iCh, pUserData, ref lpiSize, iStartSamplePos);
		}
		public bool ulaSDKSetHwInfo(int iIndex, int iValue)
		{
			return _ulaSDKSetHwInfo(iIndex, ref iValue);
		}
        public int ulaSDKGetMaxSamplesNum()
        {
            return _ulaSDKGetMaxSamplesNum();
        }
        public int ulaSDKGetSamplesNum()
        {
            return _ulaSDKGetSamplesNum();
        }
		public bool ulaSDKSetRamSize(int iSizeMB)
        {
			return _ulaSDKSetRamSize(iSizeMB);
        }        
        public int ulaSDKGetBufferSizeInBytes()
        {
            return _ulaSDKGetBufferSizeInBytes();
        }
		public int ulaSDKGetLastError()
		{
			return _ulaSDKGetLastError();
		}
		public bool ulaSDKSaveAsLawFile(string strFilePathName)
		{
			byte[] szPathName = System.Text.Encoding.ASCII.GetBytes(strFilePathName + "\0");
			return _ulaSDKSaveAsLawFile(szPathName);
		}
		public bool ulaSDKSaveAsLawFileWithTemplate(string strFilePathName, string strFileTemplate)
		{
			byte[] szPathName = System.Text.Encoding.ASCII.GetBytes(strFilePathName + "\0");
			byte[] szTemplateName = System.Text.Encoding.ASCII.GetBytes(strFileTemplate + "\0");
			return _ulaSDKSaveAsLawFileWithTemplate(szPathName, szTemplateName);
		}
		
		public bool ulaSDKGetTimingInfo(ref Int64 i64TrHead, ref Int64 i64TrEnd, ref Int64 i64TrPos)
		{
			return _ulaSDKGetTimingInfo(ref i64TrHead, ref i64TrEnd, ref i64TrPos);
		}
		public bool ulaSDKGetDataAt(ref Int64 pi64Data, Int64 i64TransPos)
		{
			return _ulaSDKGetDataAt(ref pi64Data, i64TransPos);
		}
		public bool ulaSDKGetNextData(ref Int64 pi64Data, ref Int64 i64TransPos)
		{
			return _ulaSDKGetNextData(ref pi64Data, ref i64TransPos);
		}
		
		public bool ulaSDKStopCapture()
		{
			return _ulaSDKStopCapture();
		}
    }

}


